/* MyApplication */

#import <Cocoa/Cocoa.h>
#import <CoreMIDI/MIDIServices.h>

@interface MyApplication : NSObject
{
    IBOutlet NSButton *autoReceive;
    IBOutlet NSButton *autoSend;
    IBOutlet NSButton *connectionButton;
    IBOutlet NSPanel *connectionWindow;
	IBOutlet NSOutlineView *doubledBloomsView;
    IBOutlet NSWindow *doubledBloomsWindow;
    IBOutlet NSPopUpButton *midiInput;
    IBOutlet NSPopUpButton *midiOutput;
	
    MIDIClientRef	midiClient;
    MIDIPortRef		midiInPort, midiOutPort;
    MIDIEndpointRef 	currentMidiInEndpoint, currentMidiOutEndpoint;
	Boolean askForAllPresets;
}
- (IBAction)checkDoubledBlooms:(id)sender;
- (IBAction)connect:(id)sender;
- (IBAction)receiveAllPresets:(id)sender;


-(Boolean)isAskedForAllPresets;
-(void)setAskedForAllPresets:(Boolean)value;
-(void)receiveAllData;
-(void)sendData:(char*)midiCommand;
-(void)sendAllData:(char*)midiCommand;
-(void)receiveAllDataNotification:(NSNotification*)note;
-(void)sendToMyDocument:(int)midiCommand :(int)midiValue;
-(void)sendToMyDocument:(Byte[])midiCommand ;

@end
